<template>
    <section>
        <h2>Your Wallet</h2>

        <div class="card bg-transparent" style="min-height: 4rem;">
            <div class="card-body">
                <h3 class="card-title">Request Withdraw</h3>

                <form>
                    <div class="form-group">
                        <label for="amountInput">Amount</label>
                        <input type="number" v-model="amount" v-bind:class="['form-control',  {'is-invalid' : validationError && validationError.amount}]" id="amountInput">

                        <template v-if="validationError && validationError.amount">
                            <span class="invalid-feedback">
                                <strong>{{ validationError.amount[0] }}</strong>
                            </span>
                        </template>
                    </div>

                    <div class="alert alert-success" v-if="success">
                        {{ success.message }}
                        <button type="button" class="close" v-on:click.prevent="success = '';" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>

                    <div class="alert alert-danger" v-if="fail">
                        {{ fail.message }}
                        <button type="button" class="close" v-on:click.prevent="fail = '';" aria-label="Close">
                            <span aria-hidden="true">&times;</span>
                        </button>
                    </div>

                    <button type="submit" class="btn btn-primary" v-if="loading" disabled><i class="fas fa-spinner fa-spin"></i> Request</button>
                    <button type="submit" class="btn btn-primary" v-else v-on:click.prevent="requestWithdraw">Request</button>

                </form>

            </div>
        </div>

        <hr>

    </section>
</template>

<script>
    export default {
        data: function () {
            return {
                // Form input amount
                amount: '',

                // Validation Error object
                validationError: '',

                // Loading flag
                loading: false,

                // Status flags
                success: null,
                fail: null,
            }
        },
        methods: {
            requestWithdraw: function () {
                // Show the loading
                this.loading = true;

                // Clear previous status flags
                this.success = null;
                this.fail = null;
                this.validationError = '';

                // make a request to the api
                axios.post('/api/publisher/withdraw-request/new', { 'amount' : this.amount})
                    .then(response => {
                        this.success = {
                            'message': 'Withdraw Request Created Successfully'
                        };

                        // Clear previous inputs
                        this.amount = '';
                    })
                    .catch(error => {
                        if (error.response) {
                            // The request was made and the server responded with a status code
                            // that falls out of the range of 2xx
                            console.log(error.response.status);

                            // Handle validation errors
                            if (error.response.status === 422) {
                                this.validationError = error.response.data.errors;
                            } else if(error.response.status === 403) {
                                this.fail = {
                                    message: 'You are not allowed to add a new ad unit to this content.'
                                };
                            } else {
                                this.fail = {
                                    message: error.response.stats + ' Something went wrong.'
                                };
                            }

                        } else if (error.request) {
                            // The request was made, but no response was received
                            console.log(error.request);

                            this.fail = {
                                message: 'Check your connection and try again.'
                            };

                        } else {
                            // Something happened in setting up the request that triggered an error
                            console.log('Error', error.message);

                            this.fail = {
                                message: 'Something went wrong. Please Try Again'
                            };
                        }
                    })
                    .then(e => {
                        // Hide the loading
                        this.loading = false;
                    });
            }
        },
        mounted() {
            console.log('Publisher - Create Withdraw Request mounted.')
        }
    }
</script>
